def lunar_sum(a, b):
    max_len = max(len(a), len(b))
    a = a.zfill(max_len)
    b = b.zfill(max_len)
    result = []
    for i in range(max_len):
        result.append(str(max(int(a[i]), int(b[i]))))
    
    return ''.join(result)

def lunar_product(a, b):
    max_len_a = len(a)
    max_len_b = len(b)
    results = []
    for i in range(max_len_b):
        row = []
        for j in range(max_len_a):
            row.append(str(min(int(a[j]), int(b[i]))))
        results.append(''.join(row))
    final_result = ['0'] * (max_len_a + max_len_b - 1)
    for i in range(len(results)):
        row = results[i]
        for j in range(len(row)):
            final_result[j] = str(max(int(final_result[j]), int(row[j])))
    
    return ''.join(final_result)

a = input().strip()
b = input().strip()

sum_result = lunar_sum(max(a,b), min(a,b))
product_result = lunar_product(max(a,b), min(a,b))

print(sum_result, product_result)
