import collections

def woof():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)
        graph[v].append(u)

    guarded_warehouses = set()
    for guard_pos, guard_range in guards:
        queue = collections.deque([(guard_pos, 0)])
        visited = {guard_pos}
        distances = {}
        distances[guard_pos] = 0

        while queue:
            curr_node, curr_dist = queue.popleft()
            distances[curr_node] = curr_dist

            if curr_dist > guard_range:
              continue

            for neighbor in graph[curr_node]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, curr_dist + 1))

        for warehouse, dist in distances.items():
            if dist <= guard_range:
                guarded_warehouses.add(warehouse)

    guarded_warehouses_list = sorted(list(guarded_warehouses))
    print(len(guarded_warehouses_list))
    print(*guarded_warehouses_list) if guarded_warehouses_list else print()

woof()

